/*
** $Id: client.js,v 1.26 2007/08/20 12:42:53 jakub Exp $
** Pazpar2's javascript client .
*/

// check for pz2.js
if(typeof window.pz2 == "undefined"){
    throw new Error("Client requires pz2.js library.");
}

// check for jQuery
if(typeof window.jQuery == "undefined"){
    throw new Error("Client requires requires jQuery library");
}
 
//get the language file
var langRequest = 
    //new pzHttpRequest("index.php?command=include&name=front-"+confLangCode+"&ext=xml&path=lang");
      new pzHttpRequest("locale/front-"+confLangCode+".xml");

langRequest.get(
    {},
    parseLangConf
);

/* start with creating pz2 object and passing it event handlers*/
var my_paz = new pz2( { "onshow": my_onshow,
                    //"showtime": 1000,
                    //"onstat": my_onstat,
                    "onterm": my_onterm,
                    "termlist": confTermlists.join(','),
                    //"onbytarget": my_onbytarget,
                    "autoInit": false,
                    "errorhandler": my_errorhandler,
                    //"detailstylesheet": "index.php?command=include&details="+confDetailsXsl,
                    "detailstylesheet": "xsl/" + confDetailsXsl + '.xsl',
                    "onreset": my_onreset,
                    "onrecord": my_onrecord } );

/* some state variable */
var currentSort = confSort;
var currentResultsPerPage = confShowPerPage;
var currentPage = 0;
var curQuery = new pzQuery();

/* detailed view of the selected record */
var currentDetailedId = null;
var currentDetailedData = null;
var justRedrawnId = null;

/* if termlists are controled from stylesheet this should be set to false */
var termStartup = false;

/* advanced search is set to false on the page load */
var advancedOn = false;

/* TODO do it smart */
var viewTaken = false;
var gotResults = false;
var termlistRefreshCounter = 0;

/* config to be parsed when the dom is ready */
var lang;

/* wait until the DOM is ready and register basic handlers */
$(document).ready( 
    function() {
        
        $.historyInit(historyHandler);

        document.search.query.focus();
        
        /*$('.search').corner('bottom');
        $('.leftbar').corner();
        $('.content').corner();*/
        
        /* if authentication is disabled init the pz2 session */
        if(typeof window.Auth == "undefined"){
            my_paz.init();
        }

        $('#aboutLink').click(
            function() {
                viewTaken = true;
                $('div.content').hide();
                $("div.leftbar").hide();
                $('#helpDiv').hide();
                $('#aboutDiv').show();
                return false;
            }
        );

        $('#helpLink').click(
            function() {
                viewTaken = true;
                $('div.content').hide();
                $("div.leftbar").hide();
                $('#aboutDiv').hide();
                $('#helpDiv').show();
                return false;
            }
        );
        
        document.search.query.disabled = '';
        document.search.onsubmit = onFormSubmitEventHandler;
        document.search.query.value = '';
        document.search.title.value = '';
        document.search.author.value = '';
        document.search.subject.value = '';
        document.search.date.value = '';
        
        $('#advanced').click(toggleAdvanced);

        $('#sort').change(
            function(){ 
                currentSort = this.value;
                currentPage = 0;
                my_paz.show(0, currentResultsPerPage, currentSort);
            }
        );
        
        $('#perpage').change(
            function(){ 
                currentResultsPerPage = Number(this.value);
                currentPage = 0;
                my_paz.show(0, currentResultsPerPage, currentSort);
            }
        );
        
        $('.termTitle').click (
            function() {
                if( this.firstChild.className == "selected" ) {
                    this.firstChild.className = "unselected";
                    $(this).siblings('.termEntries').hide();
                } else {
                    this.firstChild.className = "selected";
                    $(this).siblings('.termEntries').show();
                }
                return false;
            }
        );
    }
);

/*
*********************************************************************************
** pz2 Event Handlers ***********************************************************
*********************************************************************************
*/
function my_errorhandler(err)
{
    switch (err.message) 
    {
        case 'QUERY': alert(msg['errquery']); break;
        case 'NOTARGETS': alert(msg['errtargets']); break;        
        default: alert(err.message);
    }
}

function my_onreset()
{
    $('div.showing').empty();
    $('div.pages').empty();
    $('div.records').empty();

    $('div.content').hide();
    $("div.leftbar").hide();
}

/*
** data.hits["md-title"], data.hits["md-author"], data.hits.recid, data.hits.count
** data.activeclients, data.merged, data.total, data.start, data.num 
*/
function my_onshow(data)
{
    if ( data.hits.length )
        gotResults = true;

    /* TODO this is only temporary */
    if ( !viewTaken )
        $('div.content').show();

    var recsBody = $('div.records');
    recsBody.empty();
    
    for (var i = 0; i < data.hits.length; i++) {
        var title = data.hits[i]["md-title"] || 'N/A';
        var author = data.hits[i]["md-author"] || '';
        var id = data.hits[i].recid;
        var count = data.hits[i].count || 1;
        
        var recBody = $('<div class="record" id="'+ id +'"></div>');
        var aTitle = $('<a href="show_details" class="recTitle">'+title+' </a>').appendTo(recBody);
        aTitle.click(function(){
                        var clickedId = this.parentNode.id;
                        
                        if (currentDetailedId != null)
                            $( document.getElementById(currentDetailedId) )
                                .children('.detail').remove();
                        
                        if(currentDetailedId == clickedId) {
                            currentDetailedId = null;
                            justRedrawnId = null;
                            return false;
                        }
                        
                        currentDetailedId = clickedId;
                        my_paz.record(currentDetailedId);
                        return false;
                        });
        
        if( author ) {
            recBody.append('<i> by </i>');
            $('<a href="limit_by_author" name="author" class="recAuthor">'
                +author+'</a>\n').click(
                    function() { 
                            redirect(this.name, this.firstChild.nodeValue);
                            return false;
                            }
                        ).appendTo(recBody);
        }

        if( currentDetailedId == id ) {
            var detailBox = $('<div class="detail"></div>').appendTo(recBody);
            //drawDetailedRec(detailBox);
            drawDetailedRecWithXsl(detailBox);
            justRedrawnId = id;
        }

        if( count > 1 ) {
            recBody.append('<span> ('+count+')</span>');
        }

        recsBody.append('<div class="resultNum">'+(currentPage*currentResultsPerPage+i+1)+'.</a>');
        recsBody.append(recBody);
    }
    drawPager(data.merged, data.total);    
}

/*
** data.activeclients, data.hits, data.records, data.clients, data.searching
*/
function my_onstat(data){}

/*
** data[listname]: name, freq, [id]
*/
function my_onterm(data)
{
    if ( !viewTaken )
        $('div.leftbar').show();
    
    // hack as long as the termlist command doesn't block
    termlistRefreshCounter++;
    
    // obsolete
    if(termStartup)
    {   
        var termLists = $("#termlists");
        
        for(var key in data){
            if (key == "activeclients")
                continue;
            var listName = key;
            var listClass = "unselected";

            if (key == "xtargets"){
                listName = "resource";
                listClass = "selected";
            }

            var termList = $('<div class="termlist" id="term_'+key+'"/>').appendTo(termLists);
            var termTitle = $('<div class="termTitle"><a href="toggle_facet" class="'+listClass+'">'+listName+'</a></div>').appendTo(termList);
            termTitle.click(
                        function(){
                            if( this.firstChild.className == "selected" ){
                                this.firstChild.className = "unselected";
                                $(this.nextSibling).hide();
                            } else {
                                this.firstChild.className = "selected";
                                $(this.nextSibling).show();
                            }
                            return false;
                        });

            listEntries = $('<div class="termEntries"></div>');
            if (key != "xtargets") listEntries.hide();
            listEntries.appendTo(termList);

            for(var i = 0; i < data[key].length; i++)
            {
                if (key == "xtargets"){
                    var listItem = $('<a href="limit_by_resource" class="sub" name="xtarget" value="'
                                    +data[key][i].id+'">'+data[key][i].name
                                    +'<span> ('+data[key][i].freq+')</span>'+'</a>');
                    listItem.click(
                        function(){ 
                            refine(this.name, this.attributes[0].nodeValue, this.firstChild.nodeValue);
                            return false;
                        });
                    listItem.appendTo(listEntries);
                } else {
                    var listItem = $('<a href="limit_by_field" class="sub" name="'+key+'">'+data[key][i].name
                            +'<span> ('+data[key][i].freq+')</span>'+'</a>');
                    
                    listItem.click(
                        function(){
                            refine(this.name, this.firstChild.nodeValue);
                            return false;
                        });
                    listItem.appendTo(listEntries);
                }
            }        
            $('<hr/>').appendTo(termLists);
        }
        termStartup = false;
    } 
    else 
    {
        for(var key in data){
            if (key == "activeclients")
                continue;
            var listEntries = $('#term_'+key).children('.termEntries');
            if( data[key].length || (termlistRefreshCounter > 1) ) 
                listEntries.empty();

            for(var i = 0; i < data[key].length; i++){
                if (key == "xtargets"){
                    var listItem = $('<a href="limit_by_resource" class="sub" name="xtarget" value="'
                                    +data[key][i].id+'">'+data[key][i].name
                                    +'<span> ('+data[key][i].freq+')</span>'+'</a>')
                        .click(
                            function() {
                                refine(this.name, this.getAttribute('value'), this.firstChild.nodeValue);
                                return false;
                            });
                    listItem.appendTo(listEntries);
                } else {
                    var listItem = $('<a href="limit_by_field" class="sub" name="'
                                    +key+'">'+data[key][i].name
                                    +'<span> ('+data[key][i].freq+')</span>'+'</a>')
                        .click(
                            function() {
                                refine(this.name, this.firstChild.nodeValue);
                                return false;
                            });
                    listItem.appendTo(listEntries);
                }
            }         
        }
    }
}

/*
** data["md-title"], data["md-date"], data["md-author"], data["md-subject"], data["location"][0].name
*/
function my_onrecord(data)
{
    if (justRedrawnId == data.recid)
        return;
    
    currentDetailedData = data;
    detailBox = $('<div class="detail"></div>')
                        .appendTo($( document.getElementById( currentDetailedId ) ));
    //drawDetailedRec(detailBox);
    drawDetailedRecWithXsl(detailBox);
}

/*
** data[i].id, data[i].hits, data[i].diagnostic, data[i].records, data[i].state
*/
function my_onbytarget(data){}

/*
*********************************************************************************
** HELPER FUNCTIONS *************************************************************
*********************************************************************************
*/

/* search button event handler */
function encodeSession (sessHash)
{
    var sessStr = '';
    for (var key in sessHash) {
        if (sessStr != '')
            sessStr += '&';
        sessStr += key + '=' + sessHash[key];
    }
    return sessStr;
}

function decodeSession (sessStr)
{
    var fields = sessStr.split(/&/);
    var sessHash = {};
    for (var i = 0; i < fields.length; i++)
    {
        var pair = fields[i].split(/=/);
        var key = pair.shift();
        var value = pair.join('=');
        
        if ( key == 'query' )
            sessHash[key] = $.parseJSON(value);
        else
            sessHash[key] = value;
    }
    return sessHash;
}

function deSerialize (newObj, stateObj)
{
    for( var property in stateObj ) {
        if ( newObj.hasOwnProperty(property) )
            newObj[property] = stateObj[property];
    }
}

function loadStateFromSession (sessHash)
{    
    deSerialize(curQuery, sessHash['query'] );
    currentResultsPerPage = sessHash['results'];
    currentSort = sessHash['sort'];
    currentPage = Number( sessHash['page'] );
}

function saveStateInSession (action)
{
    var sessHash = { 'query': $.toJSON(curQuery),
                    'results': currentResultsPerPage,
                    'sort': currentSort,
                    'page': currentPage,
                    'action': action
                };
    return sessHash;
}

function historyHandler (sessStr)
{
    if(sessStr) {
        var sessHash = decodeSession( sessStr );

        if ( sessHash['action'] == 'show' &&
             $.toJSON( sessHash['query'] ) != $.toJSON( curQuery ) )
            sessHash['action'] = 'search';

        loadStateFromSession( sessHash );
        drawBreadcrumb();

        switch ( sessHash['action'] ) {
            case 'search' :
                my_paz.search(curQuery.toCCL(), 
                    currentResultsPerPage,
                    currentSort,
                    curQuery.getFilterString(),
                    currentPage * currentResultsPerPage );
                break;
            case 'show' :
                if (gotResults) {
                    my_paz.showPage( currentPage );
                }
                break;
        }
    }

}

//0 indexed
function showPage (pageNum)
{
    currentPage = pageNum;
    var sessHash = saveStateInSession('show');
    $.historyLoad( encodeSession(sessHash) );

    //my_paz.showPage(pageNum);
    //currentPage = pageNum;
}

function onFormSubmitEventHandler() 
{
    backToSearch();
    loadQueryFromForm();
    curQuery.clearSingleFilter();
    fireSearch();
    return false;
}

function fireSearch()
{
    my_paz.stop();
    $('div.showing').empty().text(msg['norecords']);
    $('div.pages').empty().html('&nbsp;');
    $('div.records').empty();
    
    currentPage = 0;
    currentDetailedId = null;
    termlistRefreshCounter = 0;
    
    drawBreadcrumb();

    if( !curQuery.totalLength() ) {
        $('.termEntries').empty();
        $('div.content').hide();
        $("div.leftbar").hide();
        return false;
    }
   
   /* my_paz.search(curQuery.toCCL(), 
                    currentResultsPerPage,
                    currentSort,
                    curQuery.getFilterString() );
    */
    var sessHash = saveStateInSession('search');
    $.historyLoad( encodeSession(sessHash) );
}

function toggleAdvanced()
{
    if(advancedOn){
        advancedOn = false;

        $("input[@name=query]").attr("disabled", "");
        
        $("div.advanced").hide();
        $("div.search").height(73);

        $("#advancedLinkText").show();
        $("#simpleLinkText").hide();
    } else {
        advancedOn = true;
        
        $("input[@name=query]").attr("disabled", "disabled");

        $("div.search").height(183);
        $("div.advanced").show();

        $("#advancedLinkText").hide();
        $("#simpleLinkText").show();
        loadFormFieldsFromQuery();
    }
}

function drawDetailedRec(detailBox)
{
    detailBox.append('Details:<hr/>');
    var detailTable = $('<table></table>');
    var recDate = currentDetailedData["md-date"];
    var recSubject = currentDetailedData["md-subject"];
    var recLocation = currentDetailedData["location"];

    if( recDate )
        detailTable.append('<tr><td class="item">Published:</td><td>'+recDate+'</td></tr>');
    if( recSubject )
        detailTable.append('<tr><td class="item">Subject:</td><td>'+recSubject+'</td></tr>');
    if( recLocation )
        detailTable.append('<tr><td class="item">Available at:</td><td>&nbsp;</td></tr>');

    for(var i=0; i < recLocation.length; i++)
    {
        detailTable.append('<tr><td class="item">&nbsp;</td><td>'+recLocation[i].name+'</td></tr>');
    }

    detailTable.appendTo(detailBox);
}

function drawDetailedRecWithXsl(detailBox)
{
    // set the custom resolver
    ourlNode = currentDetailedData.xmlDoc.getElementsByTagName('md-open-url');
    if ( ourlResolver && ourlNode.length ) {
        var ourl = ourlNode[0].firstChild.nodeValue;
        ourl = ourlResolver + '?'  + ourl.split('?')[1];
        ourlNode[0].firstChild.nodeValue = ourl;
    }

    Element_appendTransformResult ( detailBox[0], 
            currentDetailedData.xmlDoc,
            currentDetailedData.xslDoc );
    
}

function refine(field, value, opt)
{
    switch(field) {
        case "author":  curQuery.addTerm('au', value); break;
        case "title":   curQuery.addTerm('ti', value); break;
        case "date":    curQuery.addTerm('date', value); break;
        case "subject": curQuery.addTerm('su', value); break;
        case "xtarget": curQuery.setSingleFilter(opt, value); break;
    }
    
    updateAdvSearchForm();
    fireSearch();
}

function redirect(field, value, opt)
{
    curQuery.reset();
    refine(field, value, opt);
}

function updateAdvSearchForm()
{
    if(advancedOn)
     loadFormFieldsFromQuery();
}

function loadQueryFromForm()
{
    curQuery.reset();

    if( advancedOn )
    {
        curQuery.simpleQuery = document.search.anywhere.value;
        curQuery.addTermsFromList(document.search.author.value, 'au');
        curQuery.addTermsFromList(document.search.title.value, 'ti');
        curQuery.addTermsFromList(document.search.date.value, 'date');
        curQuery.addTermsFromList(document.search.subject.value, 'su');
    } else {
        curQuery.simpleQuery = document.search.query.value;
    }
}

function loadFormFieldsFromQuery()
{
    document.search.anywhere.value = curQuery.simpleQuery;
    document.search.author.value = '';
    document.search.title.value = '';
    document.search.date.value = '';
    document.search.subject.value = '';

    for(var i = 0; i < curQuery.numTerms; i++)
    {
        switch( curQuery.getTermFieldByIdx(i) )
        {
            case "au": document.search.author.value += curQuery.getTermValueByIdx(i) + '; '; break;
            case "ti": document.search.title.value += curQuery.getTermValueByIdx(i) + '; '; break;
            case "date": document.search.date.value += curQuery.getTermValueByIdx(i) + '; '; break;
            case "su": document.search.subject.value += curQuery.getTermValueByIdx(i) + '; '; break;
        }
    }
}

function drawPager(max, hits)
{
    var firstOnPage = currentPage * currentResultsPerPage + 1;
    var lastOnPage = (firstOnPage + currentResultsPerPage - 1) < max 
                            ? (firstOnPage + currentResultsPerPage - 1) 
                            : max;

    var results = $('div.showing');
    results.empty();
    results.append(lang["displaying"]+': <b>'
                    +firstOnPage+'</b> - <b>'+lastOnPage
                    +'</b> / <b>'+max
                    +'</b> ( '+lang["totalhits"]+': '+hits+' )');
    var pager = $('div.pages');
    pager.empty();
    
    if ( currentPage > 0 ){
        $('<a href="prev" class="previous_active">'+lang["previous"]+'</a>')
            .click(
                function() { 
                    showPage(currentPage - 1);
                    return false;
                })
            .appendTo(pager.eq(0));

        $('<a href="prev" class="previous_active">'+lang["previous"]+'</a>')
            .click(
                function() {
                    showPage(currentPage - 1)
                    return false;
                })
            .appendTo(pager.eq(1));
    }
    else
        pager.append('<a style="cursor: default;" class="previous_inactive">'+lang["previous"]+'</a>');

    var numPages = Math.ceil(max / currentResultsPerPage);

    var start = ( currentPage - 5 > 0 ? currentPage - 5 : 1 );
    var stop =  ( start + 12 < numPages ? start + 12 : numPages );

    if (start > 1) $('<span>... </span>').appendTo(pager);
    
    for(var i = start; i <= stop; i++)
    {
        if( i == (currentPage + 1) ){
           $('<a class="select">'+i+'</a>').appendTo(pager);
           continue;
        }
        var pageLink = $('<a href="page" class="page">'+i+'</a>');
        var plClone = pageLink.clone();

        pageLink.click(
            function() { 
                showPage(this.firstChild.nodeValue - 1);
                return false;
            });

        plClone.click(
            function() { 
                showPage(this.firstChild.nodeValue - 1);
                return false;
            });

        //nasty hack
        pager.eq(0).append(pageLink);
        pager.eq(1).append(plClone);
    }

    if (stop < numPages) $('<span> ...</span>').appendTo(pager);

    if ( currentPage < (numPages-1) ){
        $('<a href="next" class="next_active">'+lang["next"]+'</a>')
            .click(
                function() { 
                    showPage(currentPage + 1); 
                    return false;
                })
            .appendTo(pager.eq(0));

        $('<a href="next" class="next_active">'+lang["next"]+'</a>')
            .click(
                function() {
                    showPage(currentPage + 1);
                    return false;
                })
            .appendTo(pager.eq(1));
    }
    else
        pager.append('<a style="cursor: default;" class="next_inactive">'+lang["next"]+'</a>');
}

function drawBreadcrumb()
{
    var bc = $("#breadcrumb");
    bc.empty();
    
    if(curQuery.singleFilter) 
        $('<strong id="filter"><a href="remove_limit">'
                        +curQuery.getSingleFilterName()+'</a>: </strong>')
                            .click(
                                function() {
                                    curQuery.clearSingleFilter();
                                    updateAdvSearchForm();
                                    fireSearch();
                                    return false;
                                }
                            )
                            .appendTo(bc);

    $('<a href="remove_limit">&nbsp;'+curQuery.simpleQuery+'&nbsp;</a>')
        .click(
            function() {
                curQuery.clearSimpleQuery();
                updateAdvSearchForm();
                fireSearch();
                return false;
            }
        )
        .appendTo(bc);

    for(var i = 0; i < curQuery.numTerms; i++){
        if ( i != 0 || curQuery.simpleQuery )
            bc.append('<strong> + </strong>');
        var bcLink = $('<a href="remove_limit" id="pos_'+i+'">'+curQuery.getTermValueByIdx(i)+'</a>')
                        .click(
                            function() { 
                                curQuery.removeTermByIdx(this.id.split('_')[1]);
                                updateAdvSearchForm();
                                fireSearch();
                                return false;
                            }
                        );
        bc.append(bcLink);
    }
}

function parseLangConf ( xmlConf )
{
    xmlConf.documentElement.normalize();
    var confEntries = xmlConf.documentElement.childNodes;

    /* parts of the interface and messages kept separetely
    ** for convenience
    */
    var langConf = new Array();
    var msgConf = new Array();

    for(var i = 0; i < confEntries.length; i++) 
    {
        if ( confEntries[i].nodeType == Node.ELEMENT_NODE ) 
        {
            if ( confEntries[i].nodeName.toLowerCase() == 'messages') 
            {
                for(var j = 0; j < confEntries[i].childNodes.length; j++) 
                {

                    if ( confEntries[i].childNodes[j].nodeType == Node.ELEMENT_NODE ) 
                    {
                        msgConf[confEntries[i].childNodes[j].nodeName.toLowerCase()] 
                            = Element_getTextContent (confEntries[i].childNodes[j] );
                    }
                }
                continue;
            }
                
            langConf[confEntries[i].nodeName.toLowerCase()] 
                    = Element_getTextContent ( confEntries[i] );
        }
    }
    
    lang = langConf;
    msg = msgConf;
}

function backToSearch ()
{
    $('#helpDiv').hide();
    $('#aboutDiv').hide();
    viewTaken = false;
    
    if ( gotResults ) {
        $('div.content').show();
        $("div.leftbar").show();
    }
}
