/* $Id: loginEvents.js,v 1.14 2007/08/14 13:45:55 marc Exp $ */

my_auth = new Auth({    "onCheck": my_oncheck,
                        "onLogin": my_onlogin,
                        "output": "json"
                        });

var loggedIn = false;
var ipAuth = false;
var targetInfo = false;

my_auth.check();

$(document).ready(
    function() {
        
        ressel = new ResourceSelect({    
                                "divId": "targetSelection",
                                "userDataWS": "/masterkey-auth/mkuserdata.php"
                                });
        ressel.loadPrevious();
        
        $('#loginButton').click(
            function(){ 
                $('#loginDiv').show();
                return false;
            }
        );

        $('#resourceButton').click(
            function(){
                $('#targetSelDiv').show();
                return false;
            }
        );
        
        $("#username").blur(checkLogin);
        $("#password").blur(checkLogin);
        $("#login").submit(checkLogin);
    }
);

function checkLogin()
{
    if(loggedIn)
        return;
    if( $("#username").val() && $("#password").val() ) {
        
        my_auth.login({ 'user': $("#username").val(), 
                        'pass': $("#password").val() });
        
        $("#message").text(msg['loggingin']);
    }
}

function logOut()
{
    loggedIn = false;
    my_paz.reset();
    
    $("#message").text( msg['login'] );
    $("#resmessage").text( msg['resselnonauth'] );    
    
    $("ul.dir").remove();
    curQuery.clearFilter();
    $("#loginForm").show();

    $("#profileButton").hide();
    $("#basketButton").hide();

    $("#loginButton").text('Login');
    
    // fallback to a policy that does not require
    // any credentials
    my_auth.login();
}

/* handlers */
function my_oncheck (data)
{
    if ( data['auth-check']['status'] == 'success' ) {
        handle_policy( data['auth-check']['policy'] );
    } else {
        my_auth.login();
    }   
}

function my_onlogin (data)
{
    if ( data['auth-login']['status'] == 'success' ) {
        handle_policy( data['auth-login']['policy'] );
    } else {
        loginFailed();
    }
}

function handle_policy ( authPolicy )
{
    if ( 'ipaddr' in authPolicy 
        && authPolicy['ipaddr']['used'] == 'yes' )
        ipSuccess( authPolicy['ipaddr']['value'] );
    
    if ( 'username' in authPolicy && 'password' in authPolicy
        && authPolicy['username']['used'] == 'yes'
        && authPolicy['password']['used'] == 'yes' )
        loginSuccess( authPolicy['username']['value'] );
}

// function my_hsfailure()
// alert(msg['errservice']);

/* ip */
function ipSuccess (ip)
{
    ipAuth = true;

    $("#resmessage").text( msg['resselisauth'].replace('$', ip) );
    $("#targetSelection").empty();
    
    initPz2();
}

function ipFailed()
{
    alert(msg['erripauth']);
}

/* credentials */
function loginSuccess (login)
{
    loggedIn = true;
    ipAuth = false; //takes precedence

    $("#message").text( msg['loggedas'].replace('$', login) );
    $("#message").append(' [<a href="#" onclick="logOut()">'+msg['logout']+'</a>]');
    $("#loginForm").hide();
    $("#resmessage").text( msg['resselisauth'].replace('$', login) );
    $("#loginButton").text( msg['logout'] );

    $("#profileButton").show();
    $("#basketButton").show();

    $("#loginDiv").hide();

    initPz2();
}

function loginFailed()
{
    $("#message").text(msg['errlogin']);
}

/* init pz2 through proxy*/
function initPz2 ()
{
    $.getJSON(
        '/masterkey-auth/pzproxy.php',
        {'command': 'init'},
        function (data) {

            targetInfo = data['init']['targets'];
            my_paz.init ( data["init"]["sessionid"] );
            ressel.build ( data["init"]["categories"] );
            changeLogo( data["init"]["logo"] );
        }
    );
}

function changeLogo (uri)
{
    if (uri) {
        document.getElementById("logo").src = uri;
    } else {
        document.getElementById("logo").src = "gfx/logo.gif";
    }
}
